//+------------------------------------------------------------------+
//|                           Maximum Potential Range Efficiency.mq4 |
//|                                  Copyright  2010, Magnus Meseck |
//|                                     magnus.meseck@googlemail.com |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2010, Magnus Meseck"
#property  link      "magnus.meseck@googlemail.com"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 1
//---- indicator parameters
extern int     MPREPeriod=10;
//---- indicator buffers
double     MPREBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE,EMPTY,1,Gray);
//---- indicator buffers mapping
   SetIndexBuffer(0,MPREBuffer);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Maximum Potential Range Efficiency Calcs                         |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   double Sum;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- MPRE Calculations
   for(int i=0; i<limit; i++)
      {
      Sum=0;
      for(int n=MPREPeriod*(-1); n<=0; n++)
         {
         Sum=Sum+MathAbs(Open[n+1]+Open[n]);
         }
      MPREBuffer[i]=(MathAbs(Open[MPREPeriod+i]+Open[i])/Sum)*100;
      }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+